Subject: Re: [Dhcpv6bis] Potential packet storm in Rebind/Reply

From: "Bernie Volz (volz)" <[email-masked]>
Date: Tue, 19 Aug 2014 15:30:19 +0000

Yup, in the stateful issues work we already identified this issue. We haven’t yet addressed it as we’re still debating on exactly what to do here. I’m not sure there is an explicit ticket (though there is in my internal memory for stateful issues).

- Bernie

From: Ted Lemon <[email-masked]<mailto:[email-masked]>>
Date: Tuesday, August 19, 2014 at 11:16 AM
To: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: [Dhcpv6bis] Potential packet storm in Rebind/Reply

We were debugging a problem with a relay agent I'm hacking on this morning; it was corrupting the IA_PD on the way through from the server to the client.   As a result, the client was receiving replies to its rebind messages that contained no IA_PD.   I figured the client was buggy, but when I consulted RFC3315, I discovered that it was actually following the spec.

In section 18.1.8, there's this bit:

   When the client receives a Reply message in response to a Renew or
   Rebind message, the client examines each IA independently.  For each
   IA in the original Renew or Rebind message, the client:

   -  sends a Request message if the IA contained a Status Code option
      with the NoBinding status (and does not send any additional
      Renew/Rebind messages)

   -  sends a Renew/Rebind if the IA is not in the Reply message

   -  otherwise accepts the information in the IA

The second bullet says to respond to the reply with another renew or rebind, and doesn't specify a time delay.   This is the wrong behavior, because of course the next response will also be broken.   What it should do is silently discard the Reply message, which is semantically invalid.   This will result in it following the appropriate exponential backoff process, rather than creating a packet storm.

This will only happen if the "server" is broken, but it's worth accounting for that case.

---

From: Ted Lemon <[email-masked]>
Date: Tue, 19 Aug 2014 17:10:25 +0000

Cool, thanks.   Sorry about the bounce messages.   I've submitted a support request, but can't do anything on my own to fix it. :/

________________________________
From: Dhcpv6bis [[email-masked]] on behalf of Bernie Volz (volz) [[email-masked]]
Sent: Tuesday, August 19, 2014 8:30 AM
To: Ted Lemon; [email-masked]
Subject: Re: [Dhcpv6bis] Potential packet storm in Rebind/Reply

- Bernie

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Thu, 21 Aug 2014 18:25:49 +0000

FYI - I added Ted's email to ticket #119 (Client Rate Limiting). It should also be dealt with in the Stateful-issues (#62 and #63) but it hasn't been addressed yet as this is part of the open issues in http://www.ietf.org/proceedings/90/slides/slides-90-dhc-2.pdf, see slide 8 (and see #4 on that slide as it points out this could result in a Renew storm).

-          Bernie

From: Ted Lemon [mailto:[email-masked]]
Sent: Tuesday, August 19, 2014 1:10 PM
To: Bernie Volz (volz); [email-masked]
Subject: RE: [Dhcpv6bis] Potential packet storm in Rebind/Reply

________________________________
From: Dhcpv6bis [[email-masked]] on behalf of Bernie Volz (volz) [[email-masked]]
Sent: Tuesday, August 19, 2014 8:30 AM
To: Ted Lemon; [email-masked]<mailto:[email-masked]>
Subject: Re: [Dhcpv6bis] Potential packet storm in Rebind/Reply
Yup, in the stateful issues work we already identified this issue. We haven't yet addressed it as we're still debating on exactly what to do here. I'm not sure there is an explicit ticket (though there is in my internal memory for stateful issues).

- Bernie

      Renew/Rebind messages)